/*
 * This file is generated by jOOQ.
 */
package de.ship.db.tables;


import de.ship.db.CommonDd;
import de.ship.db.enums.EnumIsocode;
import de.ship.db.enums.EnumTransCategory;
import de.ship.db.tables.records.VCoreTranslationLongRecord;

import java.util.Collection;

import org.jooq.Condition;
import org.jooq.Field;
import org.jooq.Name;
import org.jooq.PlainSQL;
import org.jooq.QueryPart;
import org.jooq.SQL;
import org.jooq.Schema;
import org.jooq.Select;
import org.jooq.Stringly;
import org.jooq.Table;
import org.jooq.TableField;
import org.jooq.TableOptions;
import org.jooq.impl.DSL;
import org.jooq.impl.SQLDataType;
import org.jooq.impl.TableImpl;


/**
 * This class is generated by jOOQ.
 */
@SuppressWarnings({ "all", "unchecked", "rawtypes" })
public class VCoreTranslationLong extends TableImpl<VCoreTranslationLongRecord> {

    private static final long serialVersionUID = 1L;

    /**
     * The reference instance of <code>common_dd.v_core_translation_long</code>
     */
    public static final VCoreTranslationLong V_CORE_TRANSLATION_LONG = new VCoreTranslationLong();

    /**
     * The class holding records for this type
     */
    @Override
    public Class<VCoreTranslationLongRecord> getRecordType() {
        return VCoreTranslationLongRecord.class;
    }

    /**
     * The column
     * <code>common_dd.v_core_translation_long.pk_core_translationkey</code>.
     */
    public final TableField<VCoreTranslationLongRecord, Integer> PK_CORE_TRANSLATIONKEY = createField(DSL.name("pk_core_translationkey"), SQLDataType.INTEGER, this, "");

    /**
     * The column
     * <code>common_dd.v_core_translation_long.pk_core_translation</code>.
     */
    public final TableField<VCoreTranslationLongRecord, Integer> PK_CORE_TRANSLATION = createField(DSL.name("pk_core_translation"), SQLDataType.INTEGER, this, "");

    /**
     * The column <code>common_dd.v_core_translation_long.fk_trans_key</code>.
     */
    public final TableField<VCoreTranslationLongRecord, String> FK_TRANS_KEY = createField(DSL.name("fk_trans_key"), SQLDataType.CLOB, this, "");

    /**
     * The column <code>common_dd.v_core_translation_long.isocode</code>.
     */
    public final TableField<VCoreTranslationLongRecord, EnumIsocode> ISOCODE = createField(DSL.name("isocode"), SQLDataType.VARCHAR.asEnumDataType(EnumIsocode.class), this, "");

    /**
     * The column <code>common_dd.v_core_translation_long.category</code>.
     */
    public final TableField<VCoreTranslationLongRecord, EnumTransCategory> CATEGORY = createField(DSL.name("category"), SQLDataType.VARCHAR.asEnumDataType(EnumTransCategory.class), this, "");

    /**
     * The column <code>common_dd.v_core_translation_long.value</code>.
     */
    public final TableField<VCoreTranslationLongRecord, String> VALUE = createField(DSL.name("value"), SQLDataType.CLOB, this, "");

    private VCoreTranslationLong(Name alias, Table<VCoreTranslationLongRecord> aliased) {
        this(alias, aliased, (Field<?>[]) null, null);
    }

    private VCoreTranslationLong(Name alias, Table<VCoreTranslationLongRecord> aliased, Field<?>[] parameters, Condition where) {
        super(alias, null, aliased, parameters, DSL.comment(""), TableOptions.view("""
        create view "v_core_translation_long" as  SELECT pk_core_translationkey,
          pk_core_translation,
          fk_trans_key,
          isocode,
          category,
          value
         FROM common_dd.v_core_translation
        WHERE (category = 'long'::common_dd.enum_trans_category);
        """), where);
    }

    /**
     * Create an aliased <code>common_dd.v_core_translation_long</code> table
     * reference
     */
    public VCoreTranslationLong(String alias) {
        this(DSL.name(alias), V_CORE_TRANSLATION_LONG);
    }

    /**
     * Create an aliased <code>common_dd.v_core_translation_long</code> table
     * reference
     */
    public VCoreTranslationLong(Name alias) {
        this(alias, V_CORE_TRANSLATION_LONG);
    }

    /**
     * Create a <code>common_dd.v_core_translation_long</code> table reference
     */
    public VCoreTranslationLong() {
        this(DSL.name("v_core_translation_long"), null);
    }

    @Override
    public Schema getSchema() {
        return aliased() ? null : CommonDd.COMMON_DD;
    }

    @Override
    public VCoreTranslationLong as(String alias) {
        return new VCoreTranslationLong(DSL.name(alias), this);
    }

    @Override
    public VCoreTranslationLong as(Name alias) {
        return new VCoreTranslationLong(alias, this);
    }

    @Override
    public VCoreTranslationLong as(Table<?> alias) {
        return new VCoreTranslationLong(alias.getQualifiedName(), this);
    }

    /**
     * Rename this table
     */
    @Override
    public VCoreTranslationLong rename(String name) {
        return new VCoreTranslationLong(DSL.name(name), null);
    }

    /**
     * Rename this table
     */
    @Override
    public VCoreTranslationLong rename(Name name) {
        return new VCoreTranslationLong(name, null);
    }

    /**
     * Rename this table
     */
    @Override
    public VCoreTranslationLong rename(Table<?> name) {
        return new VCoreTranslationLong(name.getQualifiedName(), null);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VCoreTranslationLong where(Condition condition) {
        return new VCoreTranslationLong(getQualifiedName(), aliased() ? this : null, null, condition);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VCoreTranslationLong where(Collection<? extends Condition> conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VCoreTranslationLong where(Condition... conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VCoreTranslationLong where(Field<Boolean> condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VCoreTranslationLong where(SQL condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VCoreTranslationLong where(@Stringly.SQL String condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VCoreTranslationLong where(@Stringly.SQL String condition, Object... binds) {
        return where(DSL.condition(condition, binds));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VCoreTranslationLong where(@Stringly.SQL String condition, QueryPart... parts) {
        return where(DSL.condition(condition, parts));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VCoreTranslationLong whereExists(Select<?> select) {
        return where(DSL.exists(select));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VCoreTranslationLong whereNotExists(Select<?> select) {
        return where(DSL.notExists(select));
    }
}
